#include <stdio.h>

void dump_image(char *filename, size_t length, int exec_all)
{
  FILE *image = fopen(filename, "w");
  size_t pos;
  int online;

  fprintf(image, " .text\n");
  fprintf(image, " .globl _code_start\n");
  fprintf(image, " .globl _code_end\n");
  fprintf(image, " .align 12\n");
  fprintf(image, "_code_start:\n");

  fprintf(image, " .byte %d", exec_all ? 0x90 : 0xc3); // nop or ret

  pos = 1;
  online = 1;

  while (pos < length)
    {
      if (online == 0)
        fprintf(image, " .byte ");
      else
        fprintf(image, ",");

      if (pos % 20 == 0)
        {
          fprintf(image, "%d\n", 0xb8); /* movl $_code_start,%eax */
          fprintf(image, " .long _code_start\n");
          pos += 5;
          online = 0;
        }
      else
        {
          fprintf(image, "%d", 0x90); // nop
          pos += 1;
          online += 1;
        }

      if (online > 20)
        {
          fprintf(image, "\n");
          online = 0;
        }
    }

  if (online > 0)
    fprintf(image, "\n");

  fprintf(image, " .byte %d\n", 0xc3);

  fprintf(image, " .align 12\n");
  fprintf(image, "_code_end:\n");

  fclose(image);
}

int main(int argc, char *argv[])
{
  dump_image("image.s", atoi(argv[1]), atoi(argv[2]));
  return 0;
}
